<?php

namespace AppBundle\Repository;

use AppBundle\Entity\User;

/**
 * TradeVirtualRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TradeVirtualRepository extends \Doctrine\ORM\EntityRepository
{
    public function getLastVirtualTradeList(int $tradeCount, string $state, int $scenario): ?array
    {
        $query = $this->createQueryBuilder('trade')
            ->andWhere('trade.state = :state')
            ->andWhere('trade.scenarioId = :scenario')
            ->setParameter('state', $state)
            ->setParameter('scenario', $scenario)
            ->orderBy('trade.id', 'DESC')
            ->setMaxResults($tradeCount)
            ->getQuery();

        $trades = $query->getResult();

        return $trades;
    }

    public function sumVirtualTradeList(string $state): float
    {
        $query = $this->createQueryBuilder('trade')
            ->andWhere('trade.state = :state')
            ->setParameter('state', $state)
            ->select('SUM(trade.realizedPl) as sumTradeList')
            ->getQuery();

        $trades = $query->getSingleScalarResult();

        return floatval($trades);
    }
}
